// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package freeje_client

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// PaymentClient is the client API for Payment service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type PaymentClient interface {
	//Получить список возможных методов пополнения
	Methods(ctx context.Context, in *Method, opts ...grpc.CallOption) (Payment_MethodsClient, error)
	//Создать счет на оплату
	CreateInvoice(ctx context.Context, in *Invoice, opts ...grpc.CallOption) (*Invoice, error)
	//Совершить оплату ApplePay
	ApplePay(ctx context.Context, in *ApplePayData, opts ...grpc.CallOption) (*ApplePayResult, error)
	//Совершить оплату Stripe
	Stripe(ctx context.Context, in *StripeData, opts ...grpc.CallOption) (*StripeResult, error)
}

type paymentClient struct {
	cc grpc.ClientConnInterface
}

func NewPaymentClient(cc grpc.ClientConnInterface) PaymentClient {
	return &paymentClient{cc}
}

func (c *paymentClient) Methods(ctx context.Context, in *Method, opts ...grpc.CallOption) (Payment_MethodsClient, error) {
	stream, err := c.cc.NewStream(ctx, &Payment_ServiceDesc.Streams[0], "/com.freeje.api.client.Payment/Methods", opts...)
	if err != nil {
		return nil, err
	}
	x := &paymentMethodsClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Payment_MethodsClient interface {
	Recv() (*Method, error)
	grpc.ClientStream
}

type paymentMethodsClient struct {
	grpc.ClientStream
}

func (x *paymentMethodsClient) Recv() (*Method, error) {
	m := new(Method)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *paymentClient) CreateInvoice(ctx context.Context, in *Invoice, opts ...grpc.CallOption) (*Invoice, error) {
	out := new(Invoice)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.Payment/CreateInvoice", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *paymentClient) ApplePay(ctx context.Context, in *ApplePayData, opts ...grpc.CallOption) (*ApplePayResult, error) {
	out := new(ApplePayResult)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.Payment/ApplePay", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *paymentClient) Stripe(ctx context.Context, in *StripeData, opts ...grpc.CallOption) (*StripeResult, error) {
	out := new(StripeResult)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.Payment/Stripe", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// PaymentServer is the server API for Payment service.
// All implementations should embed UnimplementedPaymentServer
// for forward compatibility
type PaymentServer interface {
	//Получить список возможных методов пополнения
	Methods(*Method, Payment_MethodsServer) error
	//Создать счет на оплату
	CreateInvoice(context.Context, *Invoice) (*Invoice, error)
	//Совершить оплату ApplePay
	ApplePay(context.Context, *ApplePayData) (*ApplePayResult, error)
	//Совершить оплату Stripe
	Stripe(context.Context, *StripeData) (*StripeResult, error)
}

// UnimplementedPaymentServer should be embedded to have forward compatible implementations.
type UnimplementedPaymentServer struct {
}

func (UnimplementedPaymentServer) Methods(*Method, Payment_MethodsServer) error {
	return status.Errorf(codes.Unimplemented, "method Methods not implemented")
}
func (UnimplementedPaymentServer) CreateInvoice(context.Context, *Invoice) (*Invoice, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateInvoice not implemented")
}
func (UnimplementedPaymentServer) ApplePay(context.Context, *ApplePayData) (*ApplePayResult, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ApplePay not implemented")
}
func (UnimplementedPaymentServer) Stripe(context.Context, *StripeData) (*StripeResult, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Stripe not implemented")
}

// UnsafePaymentServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to PaymentServer will
// result in compilation errors.
type UnsafePaymentServer interface {
	mustEmbedUnimplementedPaymentServer()
}

func RegisterPaymentServer(s grpc.ServiceRegistrar, srv PaymentServer) {
	s.RegisterService(&Payment_ServiceDesc, srv)
}

func _Payment_Methods_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(Method)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(PaymentServer).Methods(m, &paymentMethodsServer{stream})
}

type Payment_MethodsServer interface {
	Send(*Method) error
	grpc.ServerStream
}

type paymentMethodsServer struct {
	grpc.ServerStream
}

func (x *paymentMethodsServer) Send(m *Method) error {
	return x.ServerStream.SendMsg(m)
}

func _Payment_CreateInvoice_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Invoice)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PaymentServer).CreateInvoice(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.Payment/CreateInvoice",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PaymentServer).CreateInvoice(ctx, req.(*Invoice))
	}
	return interceptor(ctx, in, info, handler)
}

func _Payment_ApplePay_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ApplePayData)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PaymentServer).ApplePay(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.Payment/ApplePay",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PaymentServer).ApplePay(ctx, req.(*ApplePayData))
	}
	return interceptor(ctx, in, info, handler)
}

func _Payment_Stripe_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(StripeData)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PaymentServer).Stripe(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.Payment/Stripe",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PaymentServer).Stripe(ctx, req.(*StripeData))
	}
	return interceptor(ctx, in, info, handler)
}

// Payment_ServiceDesc is the grpc.ServiceDesc for Payment service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Payment_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "com.freeje.api.client.Payment",
	HandlerType: (*PaymentServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "CreateInvoice",
			Handler:    _Payment_CreateInvoice_Handler,
		},
		{
			MethodName: "ApplePay",
			Handler:    _Payment_ApplePay_Handler,
		},
		{
			MethodName: "Stripe",
			Handler:    _Payment_Stripe_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "Methods",
			Handler:       _Payment_Methods_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "client/payment.proto",
}
